library XT_CreateObject;

uses Windows, XT_API;

var
	MainWnd: HWnd;

function XT_Init(nVersion, nFlags: DWord; hMainWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	if Assigned(XWF_OutputMessage) then begin
		Result:=1;
		MainWnd:=hMainWnd;
	end else
		Result:=-1;
end;

function XT_About(hTopWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
var
	Buf: array[0..255] of WideChar;
begin
	MessageBox(hTopWnd, 'This is a sample X-Tension provided by X-Ways for demonstration purposes only.', 'Demo', MB_ICONINFORMATION);

	if XWF_GetCaseProp(nil, XWF_CASEPROP_TITLE, Buf, 255)>=0 then
		MessageBoxW(hTopWnd, Buf, 'Case Title', MB_ICONINFORMATION);
end;

function XT_Prepare(hVolume, hEvidence: THandle; nOpType: DWord; lpReserved: Pointer): LongInt; stdcall; export;
var
	NewItemID, ItemID: LongInt;
	CreationDate: TFileTime;
	Success: Bool;
	ParentFlags: Int64;
	BytesPerSector: DWord;
	DefOfs, StartSector: Int64;
	ChildObjectCreated: Boolean;

	Ofs: Int64;
	Path: array[0..255] of WideChar;
	MyCtr: THandle;
begin
	Result:=0;
	ChildObjectCreated:=false;

	XWF_GetVolumeName(hVolume, Path, 0);

	if nOpType=XT_ACTION_RVS then begin
		Result:=XT_PREPARE_EXPECTMOREITEMS;
		
		{Search for a file in the volume snapshot that is larger than 4 bytes in size
		and has no child object. Then create a child object for that item, define it to cover
		the first 4 bytes of the parent file, mark it as a virtual file.}

		for ItemID:=32 to XWF_GetItemCount(nil)-1 do begin
			if XWF_GetItemSize(ItemID)>4 then begin
				ParentFlags:=XWF_GetItemInformation(ItemID, XWF_ITEM_INFO_FLAGS, @Success);

				if Success
				and (ParentFlags and $1=0 {i.e. it is not a directory})
				and (ParentFlags and $2=0 {i.e. it has no child objects yet})
				then begin
					NewItemID:=XWF_CreateItem('Cool child object!', 0);

					if NewItemID<>-1 then begin
						XWF_SetItemParent(NewItemID, ItemID);
						XWF_SetItemInformation(NewItemID, XWF_ITEM_INFO_FLAGS, $8);

						{Mark parent as having a child object, while preserving the other flags that it may have already.}
						XWF_SetItemInformation(ItemID, XWF_ITEM_INFO_FLAGS, ParentFlags or $2);

						{Define that the new child object has its data at the beginning of the start sector of the parent.}
						XWF_GetItemOfs(ItemID, DefOfs, StartSector);
						XWF_GetVolumeInformation(hVolume, nil, @BytesPerSector, nil, nil, nil);
						XWF_SetItemOfs(NewItemID, -StartSector*BytesPerSector, StartSector);
						XWF_SetItemSize(NewItemID, 4);

						{Inherit creation date from parent.}
						CreationDate:=TFileTime(XWF_GetItemInformation(ItemID, XWF_ITEM_INFO_CREATIONTIME, @Success));
						if Success then
							XWF_SetItemInformation(NewItemID, XWF_ITEM_INFO_CREATIONTIME, Int64(CreationDate));

						XWF_AddComment(NewItemID, 'This child object was created by an X-Tension.', 0);
						ChildObjectCreated:=true;
					end;

					lStrCpyW(Path,'C:\Doof.jpg');
					NewItemID:=XWF_CreateFile('Attached file.txt', $4 or $8, 471, @Path);

					Ofs:=6;
					NewItemID:=XWF_CreateFile('Excerpt.txt', $2, 472, @Ofs);
					XWF_SetItemSize(NewItemID, 4);

					break;
				end;
			end;
		end;

		if ChildObjectCreated then
			MessageBoxW(MainWnd, 'A child object was created!', XWF_GetItemName(ItemID), MB_ICONINFORMATION)
		else
			MessageBoxA(MainWnd, 'No child object was created', 'Demo', MB_ICONHAND);
	end;

	if nOpType=XT_ACTION_DBC then begin
		//XWF_CreateEvObj(4, -4, nil, nil);
		//XWF_CreateEvObj(1, 0, 'Z:\Images\Lost Partitions.e01', nil);
		//XWF_CreateEvObj(3, 0, 'Z:\Images', nil);
	end;
end;


exports
	XT_Init,
	XT_About,
	XT_Prepare;

begin
	{Here you could insert code that gets executed when the DLL is loaded.}

end.
